#include "Graf.h"


/**
* the constructor
*
* @param i the processor's index
* @param c the processor's cost
*/
Procesor::Procesor(int i, int c) : Nod(i,c)
{
	nr_tasks = 0;
	nr_procs = 1;
	queue = NULL;
	time = 0;
	cost_comm = NULL;
}

/**
* method adding the communication costs for the specified number of processors
*
* @param v the list of communication costs
* @param n the number of processors
*/
void Procesor::addCosts(int v[], int n){
	nr_procs = n;
	cost_comm = (int *)calloc(n,sizeof(int));
	for (int i=0;i<n;i++)
		cost_comm[i]=v[i];
}

/**
* Method initializing a processor to the default values
*/
void Procesor::init(){
	nr_tasks = 0;
	time = 0;
	queue = NULL;
}

/**
* Method adding a task in the tasks queue
*
* @param task_id the index of the task we add in the list
*/
void Procesor::addTask(int task_id)
{
	if(nr_tasks  == 0)
		queue = (int * )calloc(1, sizeof(int));
	else 
		queue = (int * )realloc(queue, (nr_tasks+1)*sizeof(int));
	queue[nr_tasks++] = task_id;
}

/**
* Method printing the processor's information
*/
void Procesor::print()
{
	printf("[Procesor %i cost %lf makespan = %i queue ", id, cost, time);
	for(int i = 0 ; i < nr_tasks ; i ++)
		printf("%i ", queue[i]);
	printf("]\n");
	for(int i = 0 ; i < nr_procs ; i ++)
		printf("%i",cost_comm[i]);	
		printf("\n");

}
